## libh3 4.1.0

=== debian/changelog ===
libh3 (4.1.0-2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:45:10 +0200

libh3 (4.1.0-2) unstable; urgency=medium

  * Use -ffloat-store on *i386 and m68k. Thanks Adrian Bunk!

 -- Christoph Berg <myon@debian.org>  Thu, 09 Nov 2023 19:01:46 +0000

libh3 (4.1.0-1) unstable; urgency=medium

  * Initial release.
  * Package required by h3-pg.

 -- Christoph Berg <myon@debian.org>  Sun, 05 Nov 2023 10:26:10 +0000
