=== debian/control ===
Source: libh3
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 cmake (>= 3.20),
 debhelper-compat (= 13),
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://h3geo.org/
Vcs-Browser: https://salsa.debian.org/postgresql/libh3
Vcs-Git: https://salsa.debian.org/postgresql/libh3.git

Package: libh3-dev
Architecture: any
Depends:
 libh3-1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Hexagonal hierarchical geospatial indexing system - header files
 H3 is a geospatial indexing system using a hexagonal grid that can be
 (approximately) subdivided into finer and finer hexagonal grids, combining the
 benefits of a hexagonal grid with S2's hierarchical subdivisions.
 .
 This package contains the development headers.

Package: libh3-1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Hexagonal hierarchical geospatial indexing system - library
 H3 is a geospatial indexing system using a hexagonal grid that can be
 (approximately) subdivided into finer and finer hexagonal grids, combining the
 benefits of a hexagonal grid with S2's hierarchical subdivisions.
 .
 This package contains the shared library.

Package: libh3-bin
Architecture: any
Multi-Arch: foreign
Depends:
 libh3-1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Hexagonal hierarchical geospatial indexing system - CLI programs
 H3 is a geospatial indexing system using a hexagonal grid that can be
 (approximately) subdivided into finer and finer hexagonal grids, combining the
 benefits of a hexagonal grid with S2's hierarchical subdivisions.
 .
 This package contains CLI front-end programs.
