=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifneq ($(filter %i386 m68k,$(DEB_HOST_ARCH)),)
# avoid excess precision on i386 and m68k
export DEB_CFLAGS_MAINT_APPEND += -ffloat-store
endif

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=1
