## libh3 4.2.0

=== debian/changelog ===
libh3 (4.2.0-1) unstable; urgency=medium

  * New upstream version 4.2.0.
  * Add debian/libh3-1.symbols.
  * Disable fuzzer_crash test, doesn't work on s390x.

 -- Christoph Berg <myon@debian.org>  Mon, 09 Dec 2024 13:40:53 +0100

libh3 (4.1.0-3) unstable; urgency=medium

  * Patch CMakeLists.txt to use CMAKE_INSTALL_LIBDIR (Closes: #1064956)

 -- Bradford D. Boyle <bradford.d.boyle@gmail.com>  Wed, 01 May 2024 09:45:57 +0200
