## libh3 4.2.1

=== debian/changelog ===
libh3 (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1.

 -- Christoph Berg <myon@debian.org>  Mon, 10 Mar 2025 21:25:00 +0100
