## libh3 4.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -242,6 +242,8 @@
     src/apps/testapps/testGetIcosahedronFaces.c
     src/apps/testapps/testLatLng.c
     src/apps/testapps/testLatLngInternal.c
+    src/apps/testapps/testGridRing.c
+    src/apps/testapps/testGridRingInternal.c
     src/apps/testapps/testGridRingUnsafe.c
     src/apps/testapps/testH3SetToVertexGraphInternal.c
     src/apps/testapps/testBBoxInternal.c
@@ -322,4 +324,3 @@
 # missing from our list), but is not done as the authoritative list as per CMake
 # developer recommendations. See
 # https://cmake.org/cmake/help/latest/command/file.html#glob-recurse
-option(AUDIT_SOURCE_FILE_LIST
