=== debian/changelog ===
libh3 (4.3.0-2) unstable; urgency=medium

  * Mark libh3-dev M-A: same.

 -- Christoph Berg <myon@debian.org>  Wed, 15 Oct 2025 10:15:56 +0200

libh3 (4.3.0-1) experimental; urgency=medium

  * New upstream version 4.3.0.

 -- Christoph Berg <myon@debian.org>  Wed, 18 Jun 2025 11:04:33 +0200
