=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,9 @@
 export DEB_CFLAGS_MAINT_APPEND += -ffloat-store
 endif
 
+# fix printf decimal separator in test suite
+export LC_NUMERIC=C
+
 %:
 	dh $@ --buildsystem cmake
