## libh3 4.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -259,6 +259,8 @@
     src/apps/testapps/testLinkedGeoInternal.c
     src/apps/testapps/mkRandGeo.c
     src/apps/testapps/testH3Api.c
+    src/apps/testapps/testIndexDigits.c
+    src/apps/testapps/testConstructCell.c
     src/apps/testapps/testCellsToLinkedMultiPolygon.c
     src/apps/testapps/testCellToLocalIj.c
     src/apps/testapps/testCellToLocalIjInternal.c
@@ -291,6 +293,7 @@
     src/apps/fuzzers/fuzzerEdgeLength.c
     src/apps/fuzzers/fuzzerCellProperties.c
     src/apps/fuzzers/fuzzerIndexIO.c
+    src/apps/fuzzers/fuzzerConstructCell.c
     src/apps/fuzzers/fuzzerResolutions.c
     src/apps/fuzzers/fuzzerHierarchy.c
     src/apps/fuzzers/fuzzerVertexes.c
@@ -321,6 +324,3 @@
     ${H3_BIN_SOURCE_FILES} ${OTHER_SOURCE_FILES})
 
 # This is done for quality control purposes (to detect if any source files are
-# missing from our list), but is not done as the authoritative list as per CMake
-# developer recommendations. See
-# https://cmake.org/cmake/help/latest/command/file.html#glob-recurse
