=== debian/changelog ===
libh3 (4.4.0-1) unstable; urgency=medium

  * New upstream version 4.4.0.

 -- Christoph Berg <myon@debian.org>  Fri, 07 Nov 2025 13:40:40 +0100
