=== debian/watch ===
version=4
https://github.com/uber/h3/tags .*/v(.*).tar.gz
