## libh3 4.4.1

=== debian/changelog ===
libh3 (4.4.1-1) unstable; urgency=medium

  * New upstream version 4.4.1.

 -- Christoph Berg <myon@debian.org>  Thu, 13 Nov 2025 10:06:59 +0100
