=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
 
 Package: libh3-dev
 Architecture: any
+Multi-Arch: same
 Depends:
  libh3-1 (= ${binary:Version}),
  ${misc:Depends},
